git-rebase.shon commit Merge branch 'js/remote-show-push' (c5a07b3)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .dotest working files, use the command
  18git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.  You must be in the top
  22directory of your project to start (or continue) a rebase.
  23
  24Example:       git-rebase master~1 topic
  25
  26        A---B---C topic                   A'\''--B'\''--C'\'' topic
  27       /                   -->           /
  28  D---E---F---G master          D---E---F---G master
  29'
  30
  31SUBDIRECTORY_OK=Yes
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest=$GIT_DIR/.dotest-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git-ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget update-index?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        if ! git-diff-index --quiet HEAD
  63        then
  64                if ! git-commit -C "`cat $dotest/current`"
  65                then
  66                        echo "Commit failed, please do not call \"git commit\""
  67                        echo "directly, but instead do one of the following: "
  68                        die "$RESOLVEMSG"
  69                fi
  70                printf "Committed: %0${prec}d" $msgnum
  71        else
  72                printf "Already applied: %0${prec}d" $msgnum
  73        fi
  74        echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
  75                                sed 's/^[a-f0-9]\+ //'`
  76
  77        prev_head=`git-rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat $dotest/cmt.$1)"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git-rev-parse --verify HEAD)
  90        cmt_name=$(git-symbolic-ref HEAD)
  91        msgnum=$(cat $dotest/msgnum)
  92        end=$(cat $dotest/end)
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='"$(cat $dotest/onto_name)"'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                test -d "$GIT_DIR/rr-cache" && git-rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118finish_rb_merge () {
 119        rm -r "$dotest"
 120        echo "All done."
 121}
 122
 123while case "$#" in 0) break ;; esac
 124do
 125        case "$1" in
 126        --continue)
 127                git-diff-files --quiet || {
 128                        echo "You must edit all merge conflicts and then"
 129                        echo "mark them as resolved using git update-index"
 130                        exit 1
 131                }
 132                if test -d "$dotest"
 133                then
 134                        prev_head="`cat $dotest/prev_head`"
 135                        end="`cat $dotest/end`"
 136                        msgnum="`cat $dotest/msgnum`"
 137                        onto="`cat $dotest/onto`"
 138                        continue_merge
 139                        while test "$msgnum" -le "$end"
 140                        do
 141                                call_merge "$msgnum"
 142                                continue_merge
 143                        done
 144                        finish_rb_merge
 145                        exit
 146                fi
 147                git am --resolved --3way --resolvemsg="$RESOLVEMSG"
 148                exit
 149                ;;
 150        --skip)
 151                if test -d "$dotest"
 152                then
 153                        if test -d "$GIT_DIR/rr-cache"
 154                        then
 155                                git-rerere clear
 156                        fi
 157                        prev_head="`cat $dotest/prev_head`"
 158                        end="`cat $dotest/end`"
 159                        msgnum="`cat $dotest/msgnum`"
 160                        msgnum=$(($msgnum + 1))
 161                        onto="`cat $dotest/onto`"
 162                        while test "$msgnum" -le "$end"
 163                        do
 164                                call_merge "$msgnum"
 165                                continue_merge
 166                        done
 167                        finish_rb_merge
 168                        exit
 169                fi
 170                git am -3 --skip --resolvemsg="$RESOLVEMSG"
 171                exit
 172                ;;
 173        --abort)
 174                if test -d "$GIT_DIR/rr-cache"
 175                then
 176                        git-rerere clear
 177                fi
 178                if test -d "$dotest"
 179                then
 180                        rm -r "$dotest"
 181                elif test -d .dotest
 182                then
 183                        rm -r .dotest
 184                else
 185                        die "No rebase in progress?"
 186                fi
 187                git reset --hard ORIG_HEAD
 188                exit
 189                ;;
 190        --onto)
 191                test 2 -le "$#" || usage
 192                newbase="$2"
 193                shift
 194                ;;
 195        -M|-m|--m|--me|--mer|--merg|--merge)
 196                do_merge=t
 197                ;;
 198        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 199                --strateg=*|--strategy=*|\
 200        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 201                case "$#,$1" in
 202                *,*=*)
 203                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 204                1,*)
 205                        usage ;;
 206                *)
 207                        strategy="$2"
 208                        shift ;;
 209                esac
 210                do_merge=t
 211                ;;
 212        -v|--verbose)
 213                verbose=t
 214                ;;
 215        -C*)
 216                git_am_opt=$1
 217                shift
 218                ;;
 219        -*)
 220                usage
 221                ;;
 222        *)
 223                break
 224                ;;
 225        esac
 226        shift
 227done
 228
 229# Make sure we do not have .dotest
 230if test -z "$do_merge"
 231then
 232        if mkdir .dotest
 233        then
 234                rmdir .dotest
 235        else
 236                echo >&2 '
 237It seems that I cannot create a .dotest directory, and I wonder if you
 238are in the middle of patch application or another rebase.  If that is not
 239the case, please rm -fr .dotest and run me again.  I am stopping in case
 240you still have something valuable there.'
 241                exit 1
 242        fi
 243else
 244        if test -d "$dotest"
 245        then
 246                die "previous dotest directory $dotest still exists." \
 247                        'try git-rebase < --continue | --abort >'
 248        fi
 249fi
 250
 251# The tree must be really really clean.
 252git-update-index --refresh || exit
 253diff=$(git-diff-index --cached --name-status -r HEAD)
 254case "$diff" in
 255?*)     echo "cannot rebase: your index is not up-to-date"
 256        echo "$diff"
 257        exit 1
 258        ;;
 259esac
 260
 261# The upstream head must be given.  Make sure it is valid.
 262upstream_name="$1"
 263upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 264    die "invalid upstream $upstream_name"
 265
 266# Make sure the branch to rebase onto is valid.
 267onto_name=${newbase-"$upstream_name"}
 268onto=$(git-rev-parse --verify "${onto_name}^0") || exit
 269
 270# If a hook exists, give it a chance to interrupt
 271if test -x "$GIT_DIR/hooks/pre-rebase"
 272then
 273        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 274                echo >&2 "The pre-rebase hook refused to rebase."
 275                exit 1
 276        }
 277fi
 278
 279# If the branch to rebase is given, first switch to it.
 280case "$#" in
 2812)
 282        branch_name="$2"
 283        git-checkout "$2" || usage
 284        ;;
 285*)
 286        if branch_name=`git symbolic-ref -q HEAD`
 287        then
 288                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 289        else
 290                branch_name=HEAD ;# detached
 291        fi
 292        ;;
 293esac
 294branch=$(git-rev-parse --verify "${branch_name}^0") || exit
 295
 296# Now we are rebasing commits $upstream..$branch on top of $onto
 297
 298# Check if we are already based on $onto, but this should be
 299# done only when upstream and onto are the same.
 300mb=$(git-merge-base "$onto" "$branch")
 301if test "$upstream" = "$onto" && test "$mb" = "$onto"
 302then
 303        echo >&2 "Current branch $branch_name is up to date."
 304        exit 0
 305fi
 306
 307if test -n "$verbose"
 308then
 309        echo "Changes from $mb to $onto:"
 310        git-diff-tree --stat --summary "$mb" "$onto"
 311fi
 312
 313# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
 314echo "First, rewinding head to replay your work on top of it..."
 315git-reset --hard "$onto"
 316
 317# If the $onto is a proper descendant of the tip of the branch, then
 318# we just fast forwarded.
 319if test "$mb" = "$branch"
 320then
 321        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 322        exit 0
 323fi
 324
 325if test -z "$do_merge"
 326then
 327        git-format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
 328        git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
 329        exit $?
 330fi
 331
 332# start doing a rebase with git-merge
 333# this is rename-aware if the recursive (default) strategy is used
 334
 335mkdir -p "$dotest"
 336echo "$onto" > "$dotest/onto"
 337echo "$onto_name" > "$dotest/onto_name"
 338prev_head=`git-rev-parse HEAD^0`
 339echo "$prev_head" > "$dotest/prev_head"
 340
 341msgnum=0
 342for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
 343                        | @@PERL@@ -e 'print reverse <>'`
 344do
 345        msgnum=$(($msgnum + 1))
 346        echo "$cmt" > "$dotest/cmt.$msgnum"
 347done
 348
 349echo 1 >"$dotest/msgnum"
 350echo $msgnum >"$dotest/end"
 351
 352end=$msgnum
 353msgnum=1
 354
 355while test "$msgnum" -le "$end"
 356do
 357        call_merge "$msgnum"
 358        continue_merge
 359done
 360
 361finish_rb_merge